import { OzoneAPIRequest } from 'ozone-api-request';
const configUrl = './conf.ozone.json';
const ozoneAPIRequest = new OzoneAPIRequest();
ozoneAPIRequest.url = configUrl;
ozoneAPIRequest.method = 'GET';
/**
 * deprecated
 */
export class OzoneConfig {
    static get() {
        if (!OzoneConfig.configPromise) {
            OzoneConfig.configPromise = ozoneAPIRequest.sendRequest()
                .then((res) => {
                const config = res.response.ozoneApi;
                const urlSearchParams = new URLSearchParams(window.location.search);
                const serverUrl = urlSearchParams.get('serverURL');
                if (serverUrl) {
                    config.host = serverUrl;
                }
                return config;
            })
                .catch((failRequest) => {
                console.error('Unable to find config at ', configUrl);
                throw new Error('Unable to find config');
            });
        }
        return OzoneConfig.configPromise;
    }
}
OzoneConfig.configPromise = null;
